<template>
  <div class="login-container">
    <el-form class="card-box sellerRegisterForm" autoComplete="on" :model="form" :rules="rules" ref="form" label-position="left">
      <h3 class="title">{{title}}</h3>

      <div v-if="page.credential">

        <el-form-item prop="name">
          <span class="pl10 c iconfont icon-denglu"></span>
          <el-input type="text" v-model="form.name" autoComplete="on" :placeholder="placeholder.name" />
        </el-form-item>

        <el-form-item prop="password">
          <span class="pl10 c iconfont icon-mima"></span>
          <el-input name="password" :type="pwdType" @keyup.enter.native="handleLogin" v-model="form.password" autoComplete="on" :placeholder="placeholder.password" />
          <span class="show-pwd iconfont icon-eye-close" @click="showPwd"></span>
        </el-form-item>

        <div style="margin-bottom:20px;">
          <el-switch v-model="isExistingUser"></el-switch>
          <span style="margin-left:10px;" class="c">{{isExistingUserPlaceholder}}</span>
        </div>
        <el-button type="primary" style="width:100%;margin-bottom:30px;float:right;" :loading="loading" @click.native.prevent="nextPage">{{label.button.next}}</el-button>
      </div>

      <div v-if="page.info">

        <el-form-item prop="realname" v-if="!isExistingUser">
          <span class="pl10 c iconfont icon-denglu"></span>
          <el-input type="text" v-model="form.realname" autoComplete="on" :placeholder="placeholder.realname" />
        </el-form-item>

        <el-form-item prop="phone">
         
          <span style="float:left;">  <span class="pl10 c iconfont icon-denglu"></span> <el-input type="text" v-model="form.phone" autoComplete="on" :placeholder="placeholder.phone" /> </span> <span style="float:right"> <el-button type="success" :loading="loading" style="height:47px;" :disabled="buttonDelay" @click.native.prevent="verifyNumber()">发送验证码</el-button> </span>
           
        </el-form-item>
        
         <el-upload class="avatar-uploader" :action="m_action" :show-file-list="false"  name="images" :with-credentials="true" :on-success="handlePhoto">
          <el-form-item :label="placeholder.photo.label" label-width="80px" prop="photo" >
          
              <img v-if="form.photo" :src="form.photo" class="avatar" style="max-width:200px;">
              <i v-else class="el-icon-plus avatar-uploader-icon" style="color:white"></i>
          
            <p class="m_red">{{placeholder.photo.placeholder}}</p>
          </el-form-item>
         </el-upload>

        <el-upload class="avatar-uploader" style="width:100%;" :action="m_action"  :show-file-list="false"  name="images" :with-credentials="true" :on-success="handleCompanyPhoto">
        <el-form-item :label="placeholder.company.photo.label" label-width="100px"  prop="company_photo">
         
             
            <img v-if="form.company.photo" :src="form.company.photo" class="avatar" style="max-width:200px;">
            <i v-else class="el-icon-plus avatar-uploader-icon" style="color:white"></i>
            
          
          <p class="m_red">{{placeholder.company.photo.placeholder}}</p>
        </el-form-item>
        </el-upload>

        <el-form-item prop="company_info">
          <span class="pl10 c iconfont icon-denglu"></span>
          <el-input type="text" v-model="form.company.info" autoComplete="on" :placeholder="placeholder.company.info" />
        </el-form-item>

        <el-form-item prop="company_no">
          <span class="pl10 c iconfont icon-denglu"></span>
          <el-input type="text" v-model="form.company.no" autoComplete="on" :placeholder="placeholder.company.no" />
        </el-form-item>

        <div style="margin-bottom:15px"> 
          <el-checkbox v-model="form.term_condition"/>
          <a href="/assets/term-condition.pdf" style="color:white; margin-left: 10px">
          阅读并接受 <a href="/assets/term-condition.pdf">《洽洽用户协议》</a> 及 <a href="/assets/term-condition.pdf">《洽洽隐私权保护声明》</a>
        </a>
        </div> 

        <el-button type="success" style="width:100%;margin-bottom:30px;float:right;" :loading="loading" @click.native.prevent="handleRegister">提交成为商家</el-button>
      </div>

    </el-form>
    <el-dialog :append-to-body="true" :close-on-click-modal="false" :visible.sync="otpform" width="500px">
      <div>
       
           <label>   输入短信中的4位数验证码 </label>
            <el-input clearable v-model="form.otpcode" auto-complete="off" style="width:40%; margin-left:20px"></el-input>
          

      </div>
      <div slot="footer">
        <el-button type="primary" @click.native.prevent="otpCheck">确 定</el-button>
         <el-button type="primary" @click.native.prevent="verifyNumber">重新发送验证码</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<style>
  a {
    color: #3EA6ff;
  }
</style>
<script>


import { mapActions, mapGetters } from 'vuex'
import * as auth from '@/api/seller/auth'
import * as api from '@/api'
import axios from '../../components/downloadFile/axios'

export default {
  name: 'register',
  data() {
    return {
      title: '注册成为商家',
      isExistingUser: false,
      isExistingUserPlaceholder: '如已有普通用户账户，请点击这里',
      page: {
        credential: true,
        info: false,
      },
      buttonDelay:false,
      form: {
        name: '', 
        realname: '', 
        password: '',
        mobile: '',
        phone: '',
        photo: '',
        exist_user: false,
        company: {
          info: '',
          no: '',
          photo: ''
        },
        otpcode:'',
        term_condition:false,
      },
      otpform:false, 
      otpverified:false,
      otporigincode:'',
      label: {
        button: {
          next: '下一步',
        },
      },
      placeholder: {
        name: '用户名', 
        realname: '法人姓名', 
        password: '密码', 
        phone: '联系人电话号码',
        photo: {
          label: '营业执照图片',
          placeholder: '( 图片不得大于1MB )'
        },
        company: {
          info: '公司名称',
          no: '统一社会信用代码',
        photo: {
          label: ' 法人身份证',
          placeholder: '( 图片不得大于1MB )'
        },
        }
      },
      rules: {
        name: [{ required: true, trigger: 'blur', message: '请输入账号' }],
        password: [{ required: true, trigger: 'blur', message: '请输入密码' }],
        phone: [{ required: true, trigger: 'blur', message: 'Phone is required' }],
        photo: [{ required: true, trigger: 'blur', message: 'Photo is required' }],
        // company_photo: [{ required: true, trigger: 'blur', message: 'Company Photo is required' }],
        // company_info: [{ required: true, trigger: 'blur', message: 'Company Info is required' }],
        // company_no: [{ required: true, trigger: 'blur', message: 'Company No is required' }],
      },
      pwdType: 'password',
      loading: false,
      showDialog: false,

      get_loading: false,
      showDialog: false,

      sendNum: 0,
      time: null,
    }
  },
  watch: {
    isExistingUser(val) {
      this.form.exist_user = val
    },
  },
  methods: {
    ...mapActions(['setRouterList', 'setViewTagList', 'GenerateRoutes']),
    showPwd() {
      if (this.pwdType === 'password') {
        this.pwdType = ''
      } else {
        this.pwdType = 'password'
      }
    },
      verifyNumber() { 
        this.buttonDelay=true
        let phone = this.form.phone
        

         if (phone == null || phone == ''){ 
           this.m_error('请填写电话字段')
           this.button=false;
           this.buttonDelay = false
         }
         else { 
           setTimeout(function(){ 
            this.buttonDelay = false
          }, 10000);
           console.log(phone) 
           auth.mobile_verify({phone:phone}).then(res => { 
             if(res.data.status != false) { 
               this.m_success('发送成功')
                this.otpform=true
                this.otporigincode = res.data.code
                console.log(res.data)
             }
           })
         }
         
         
    },
    otpCheck() { 
     if (this.form.otpcode == this.otporigincode) { 
       this.otpverified = true
       this.m_success('电话已验证')
       this.otpform = false
     }
     else {
       this.m_error('错误的代码')
     }
    },

    nextPage() {
      api.validate_user({
        'username': this.form.name,
        'is_existing': this.form.exist_user
      }).then(res => {
        console.log(res.data)
          if(res.data.can_proceed) {
            this.page = {
              credential: false,
              info: true
            }
          } else {
            this.m_error(res.data.message)
          }
      }).finally(() => {
        this.m_tableLoading = false
      })
    },
    handleRegister() {
     if (this.form.term_condition == true) {
        if (this.otpverified == true) { 
          this.$refs.form.validate(valid => {
            if (valid) {
              auth.register(this.form).then(res => {
                this.$alert('您已成功注册，请登陆商家端', '提示', {
                  confirmButtonText: '确定',
                  type:'success'
                })
                setTimeout(() => {
                  this.$router.push('login')
                }, 2000);
              }).catch((err) => {
                this.page = {
                  credential: true,
                  info: false
                }
              })
            } else {
              console.log('error submit!!')
              return false
            }
          })
        }
        else { 
          
          this.m_error('请验证您的电话号码')
        }
     } 
     else{
       this.m_error('请确认条款和条件')
     }
    },
    sendCodnTime() {
      this.time && clearInterval(this.time)
      this.sendNum = 60
      this.time = setInterval(() => {
        this.sendNum = this.sendNum - 1
        if (this.sendNum <= 0) {
          this.sendNum = 0
          clearInterval(this.time)

        }
      }, 1000)
    },
    handleRegisterSeller () {
      this.$router.push({name: 'sellerRegister'})
    },
    handlePhoto(res,file) {
      this.form.photo = res.data
      console.log(res, file)
    },
    handleCompanyPhoto(res,file) {
      this.form.company.photo = res.data
      console.log(res, file)
    },
  },
  

  computed: {

  }

}
</script>

<style rel="stylesheet/scss" lang="scss">
.c {
  color: #889aa4;
}
@import "../../assets/scss/mixin.scss";
$bg: #2d3a4b;
$dark_gray: #889aa4;
$light_gray: #eee;

.login-container {
  @include relative;
  height: 200vh !important;
  background-color: $bg;
  input:-webkit-autofill {
    -webkit-box-shadow: 0 0 0px 1000px #293444 inset !important;
    -webkit-text-fill-color: #fff !important;
  }
  input {
    background: transparent;
    border: 0px;
    -webkit-appearance: none;
    border-radius: 0px;
    padding: 12px 5px 12px 15px;
    color: $light_gray;
    height: 47px;
  }
  .el-input {
    display: inline-block;
    height: 47px;
    width: 85%;
  }
  .tips {
    font-size: 14px;
    color: #fff;
    margin-bottom: 10px;
  }
  .svg-container {
    padding: 6px 5px 6px 15px;
    color: $dark_gray;
    vertical-align: middle;
    width: 30px;
    display: inline-block;
    &_login {
      font-size: 20px;
    }
  }
  .title {
    font-size: 26px;
    font-weight: 400;
    color: $light_gray;
    margin: 0px auto 40px auto;
    text-align: center;
    font-weight: bold;
  }
  .login-form {
    position: absolute;
    left: 0;
    right: 0;
    width: 400px;
    padding: 35px 35px 15px 35px;
    margin: 10px auto;
  }
  .el-form-item {
    border: 1px solid rgba(255, 255, 255, 0.1);
    background: rgba(0, 0, 0, 0.1);
    border-radius: 5px;
    color: #454545;
  }
  .show-pwd {
    position: absolute;
    right: 10px;
    top: 7px;
    font-size: 16px;
    color: $dark_gray;
    cursor: pointer;
    user-select: none;
  }
  .thirdparty-button {
    position: absolute;
    right: 35px;
    bottom: 28px;
  }
  .el-upload { 
    width:100%
  }
  .sellerRegisterForm{
    position: absolute;
    left: 0;
    right: 0;
    width: 400px;
    padding: 35px 35px 15px 35px;
    margin: 0 auto;
  }
 
}
</style>
